package com.diagbot.rule;

import com.diagbot.dto.BillMsg;
import com.diagbot.dto.BillNeoMaxDTO;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.model.entity.Negative;
import com.diagbot.util.CoreUtil;
import com.diagbot.util.ListUtil;
import org.apache.commons.lang3.StringUtils;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @description: 通用规则提取
 * @author: kwz
 * @time: 2020/8/3 14:47
 */
public class CommonRule {

    /**
     * 比较界面元素是否在图谱中存在（匹配名称）
     *
     * @param neoList 图谱结构
     * @param inputLises 界面元素
     * @return
     */
    public static <T> void compareNameWithBill(List<NodeNeoDTO> neoList, List<T> inputLises, BillNeoMaxDTO billNeoMaxDTO, List<BillMsg> billMsgList, String type) {
        Map<String, String> old_stand = new HashMap<>();
        if (ListUtil.isNotEmpty(neoList) && ListUtil.isNotEmpty(inputLises)) {
            List<String> dl = neoList.stream().map(x -> x.getName()).collect(Collectors.toList());
            for (T d : inputLises) {
                Negative val = (Negative) CoreUtil.getFieldValue(d, "negative");
                if (val == null) {
                    String c = (String) CoreUtil.getFieldValue(d, "standName");
                    String c_name = (String) CoreUtil.getFieldValue(d, "name");
                    if (StringUtils.isNotBlank(c) && dl.contains(c)) {
                        old_stand.put(c_name, c);
                    }
                }
            }
            if (old_stand.size() > 0) {
                for (Map.Entry<String, String> d : old_stand.entrySet()) {
                    BillMsg commonBillMsg = CoreUtil.getCommonBillMsg(billNeoMaxDTO.getOrderName(), billNeoMaxDTO.getOrderStandName(), d.getKey(), d.getValue(), type);
                    billMsgList.add(commonBillMsg);
                }
            }
        }
    }
}
